<template>
    <v-layout column justify-center align-center>
        <v-layout v-if="!is_form && !in_room">
            <v-btn @click="is_form=true">Show Form Create Room</v-btn>
        </v-layout>
        <room-form v-if="is_form" v-on:create-room="createRoom" v-on:cancel-form="cancelForm"></room-form>
        <room v-if="in_room"></room>
        <v-layout v-if="!is_form && !in_room">
            <v-layout
                v-for="(room, index) in rooms"
                :key="index"
                class="light-green lighten-4 mt-4"
            >
                <div >{{room.id}}</div>
                <v-btn @click="joinRoom(room.id)">Join</v-btn>
            </v-layout>
         </v-layout>
    </v-layout>
</template>

<script>
import Room from './Room';
import RoomForm from './RoomForm';

export default {
    components: {
        RoomForm,
        Room
    },
    mounted(){
        console.log('в mounted Rooms = ', this.$socket);
        this.$socket.emit('get_rooms');
        //console.log('окно комнат');
    },
    data: () => ({
        is_form: false
    }),
    computed:{
        rooms(){return this.$store.getters['rooms/getRooms']},
        in_room(){
            if(this.$store.getters['rooms/getRoom']){
                return true;
            }
            return false;
        }
    },
    methods:{
        cancelForm(){
            this.is_form = false;
        },
        joinRoom(room_id){
            const data = {
                room_id:room_id,
                user_id: this.$store.state.user.user.id
            }
            this.$socket.emit('join_room', data);
            this.is_form = false;
        },
        createRoom(data){
            console.log('должен отослать на сервер запрос на создание комнаты');
            this.$socket.emit('create_room', data);
            console.log('событие ушло!!');
            this.is_form = false;
        }
    }
};
</script>
